#include "Annuity_Calcs_Lib1.h"


/* System header files and function prototypes are moved to Annuity_Calcs_Lib.h
		which will serve as the library header file 

	The following code including header files, prototypes and main is no longer 
	needed.  It is commented out - but left in this example to help the reader
	see the changes we are making.
_______________________________________________________________________________

/* Annuity Coding Examples 

# include <stdio.h> 
#include <math.h>

double Annuity_Amount (double, double,  int);
void Annuity_Payout(double, int, double, double[], double[]);
 
main ()
{
int	i_counter;
double Future_Value = 200000.;
double Interest_Rate = 0.01;
int Period = 20*12;
double Future_Value_Interest[1000];
double Future_Value_Annuity_Payout[1000];

double A_A = Annuity_Amount (Future_Value, Interest_Rate, Period);

printf ("Monthly Payment or Annuity Amount = %7.3lf\n\n", A_A);

double Payment = A_A;

Annuity_Payout(Interest_Rate, Period, Payment, Future_Value_Interest,
							Future_Value_Annuity_Payout);

printf("Month		End of Month	    Interest Earned       Total \n");
printf("     		Payment		    for the month	   Payment \n");

	for (i_counter = 1; i_counter <=Period; i_counter++)
	{
	printf ("  %3d        %6.2f      %6.2f         %8.2f\n", 
				        i_counter, Payment, Future_Value_Interest[i_counter] ,
						Future_Value_Annuity_Payout[i_counter]);
	}


return 0;
}

_______________________________________________________________________________

*/

double Annuity_Amount (double F_V, double I_R, int Per)
{
  return F_V*I_R/(pow((1+I_R),Per)-1);
}


void Annuity_Payout(double I_R, int Per, double Pay, double* FVI, double*  FVAP)
{
   int i;
	
   FVAP[0] = 0.;  
   for (i = 1; i <=Per; i++) 
   {
		FVI[i]  = FVAP[i-1]*I_R;	
	    FVAP[i] = FVAP[i-1] + Pay + FVI[i];	
   }
  
}

