#include "Matrix_Data_Analysis.h"

void ConvertVBA_Matrix_to_C_Matrix(double* Matrix, long Nrows, long Ncolumns, double Matrix_Row_Major[100][100])
{
	//double Matrix_Row_Major[100][100];  it is not necessary to change the size
	
	int i;
	int j;

	for(i =0; i<Nrows; ++i)
	{
		int columnPos = 0;
		for(j =0; j<Ncolumns; ++j)
		{
			Matrix_Row_Major[i][j] = *(Matrix+i+columnPos+j);
			columnPos = columnPos + Nrows;
		} 
	}
	
	return;	
}


void ConvertC_Matrix_to_VBA_Matrix(double Matrix_Row_Major[100][100], long Nrows, long Ncolumns, double* Matrix_Col_Major)
{
	int i;
	int j;

	for(i =0; i<Nrows; ++i)
	{
		int columnPos = 0;
		for(j =0; j<Ncolumns; ++j)
		{
			*(Matrix_Col_Major+i+columnPos+j) = Matrix_Row_Major[i][j];
			columnPos = columnPos + Nrows;
		} 
	}
	return;	
}


void  Compute_ADD_Column_Matrix(double* Matrix, long Nrows, long Ncolumns )
{
	int i;
	int j;
	
	double Matrix_Row_Major[100][100]; 
    ConvertVBA_Matrix_to_C_Matrix(Matrix, Nrows, Ncolumns, Matrix_Row_Major);

    for(i =0; i<Nrows; ++i)
	{
		double Sum =0;
		for(j =0; j<Ncolumns-1; ++j)
		{
			Sum = Sum + Matrix_Row_Major[i][j];
			
		} 
		Matrix_Row_Major [i][j] = Sum;
	}

    ConvertC_Matrix_to_VBA_Matrix(Matrix_Row_Major, Nrows, Ncolumns, Matrix);
	return;
}




void  Compute_AVG_Column_Matrix(double* Matrix, long Nrows, long Ncolumns, 
															double* AvgArray )
{
	int i;
	int j;
	
	double Matrix_Row_Major[100][100]; 
    ConvertVBA_Matrix_to_C_Matrix(Matrix, Nrows, Ncolumns, Matrix_Row_Major);

	for(j =0; j < Ncolumns; ++j)
	{
		double Sum = 0.0;
		for(i =0; i<Nrows; ++i)
			Sum = Sum + Matrix_Row_Major[i][j];
		AvgArray[j] = Sum/Nrows;		
	}
}


