#include "C_Matrix.h"


void ConvertVBA_Matrix_to_C_Matrix(double* Matrix, long Nrows, long Ncolumns, double Matrix_Row_Major[100][100])
{
	//double Matrix_Row_Major[100][100];  it may be necessary to change the size 
	
	int i;
	int j;

	for(i =0; i<Nrows; ++i)
	{
		int columnPos = 0;
		for(j =0; j<Ncolumns; ++j)
		{
			Matrix_Row_Major[i][j] = *(Matrix+i+columnPos+j);
			columnPos = columnPos + Nrows;
		} 
	}
	
	return;	
}


void ConvertC_Matrix_to_VBA_Matrix(double Matrix_Row_Major[100][100], long Nrows, long Ncolumns, double* Matrix_Col_Major)
{
	int i;
	int j;

	for(i =0; i<Nrows; ++i)
	{
		int columnPos = 0;
		for(j =0; j<Ncolumns; ++j)
		{
			*(Matrix_Col_Major+i+columnPos+j) = Matrix_Row_Major[i][j];
			columnPos = columnPos + Nrows;
		} 
	}
	return;	
}


void GJ_Elimination_Main(double* Matrix, long Nrows, long Ncols)
{

	double A[100][100];
	ConvertVBA_Matrix_to_C_Matrix(Matrix, Nrows, Ncols, A);
	GJ_Elimination(A, Nrows);
	ConvertC_Matrix_to_VBA_Matrix(A, Nrows, Ncols, Matrix);
}


void GJ_Elimination(double A[100][100], long row)
{
	long col = row+1;
	int nonZerIdx = 0;
	

	for(int i =0; i<row; ++i)
	{
		if(A[i][i] == 0.0)
		{
			for (int i2 = i+1; i2<row; ++i2)
			if(A[i2][i] != 0) 
			{
				nonZerIdx = i2;
				break;
			}
			for(int j1 =0; j1<col; ++j1)
			{
				double tmp =  A[i][j1];
				A[i][j1] = A[nonZerIdx][j1];
				A[nonZerIdx][j1] =tmp; 
			}
		}

		double tmpAii = A[i][i];
		for(int j =0; j<col; ++j)
			A[i][j] = A[i][j]/tmpAii;
		
		
		

		for(int i1 =0; i1<row; ++i1)
		{
			if(i1 != i)	
			{
				double tmpAi1 = A[i1][i];
				for(int j =0; j<col; ++j)
					A[i1][j] = A[i1][j] - tmpAi1*A[i][j];
			}
		}

	}

}